/************************************************************************
* "Epsilon" is a registered trademark licensed to Lugaru Software, Ltd. *
*	"EEL" and "Lugaru" are trademarks of Lugaru Software, Ltd.	*
*									*
*  Copyright (C) 1985, 1992 Lugaru Software Ltd.  All rights reserved.	*
*									*
* Limited permission is hereby granted to reproduce and modify this	*
* copyrighted material provided that the resulting code is used only in	*
* conjunction with Lugaru products and that this notice is retained in	*
* any such reproduction or modification.				*
************************************************************************/

#include "eel.h"

#ifndef EELVERSION
#define EELVERSION 50
#endif

#if EELVERSION < 60
#define spot int **
#endif

#define CLIPPER_COMMENT
#define INLINE_COMMENT

#define DB_INDENT 5

keytable db_tab;

db_indenter()		/* replace surrounding indentation with new */
{
	to_column(db_calcola_indent());
}

char db_mode_name[] = "dBase III";

command db_mode()
{
	mode_keys = db_tab;		/* use these keys */
	db_tab[')'] = db_tab[']'] = db_tab['}'] =
			Matchdelim ? (short) show_matching_delimiter : 0;
	tab_size = 3;
	indenter = db_indenter;
	auto_indent = 1;
#if EELVERSION >= 60
	comment_column = 40;
#ifdef CLIPPER_COMMENT
	strcpy(comment_start, "(/</|*>)[ \t]*");
#ifdef INLINE_COMMENT
	strcpy(comment_begin, "// \0");
	strcpy(comment_end, "\0");
#else
	strcpy(comment_begin, "/* \0");
	strcpy(comment_end, "*/\0");
#endif
#else					/* ifdef CLIPPER_COMMENT */
	strcpy(comment_start, "(^<*>[ \t]*)|(&&[ \t]*)");
#ifdef INLINE_COMMENT
	strcpy(comment_begin, "&& \0");
	strcpy(comment_end, "\0");
#else
	comment_column = 0;
	strcpy(comment_begin, "* \0");
	strcpy(comment_end, "\0");
#endif
#endif					/* ifdef CLIPPER_COMMENT */
#endif					/* if EELVERSION >= 60 */
	major_mode = db_mode_name;
	make_mode();
}

suffix_prg() { db_mode(); }

db_calcola_indent()
{
	int vecchia_fold=case_fold,prev_indent,ora_indent;
	spot pos1 = alloc_spot(), pos2=alloc_spot();
	
	*pos1=point;
	case_fold=1;
	re_search(-1, "[^ \t\n]");	/* find previous non-blank line */
	to_indentation();
	prev_indent=current_column();
	if (parse_string(1,"(if|do[ |\\t]+while|do[ |\\t]+case|for)",NULL))
		ora_indent=prev_indent+tab_size;
	else if (parse_string(1,"else|elseif",NULL)){
		*pos2=point;
		re_search(-1, "[^ \t\n]");	/* find previous non-blank line */
		to_indentation();
		prev_indent=current_column();
		if (!parse_string(1,"if|elseif",NULL)) prev_indent-=tab_size;
		point=*pos2;
		to_column(prev_indent);
		ora_indent=prev_indent+tab_size;
	}else if (parse_string(1,"case|otherwise",NULL)){
		*pos2=point;
		re_search(-1, "[^ \t\n]");	/* find previous non-blank line */
		to_indentation();
		prev_indent=current_column();
		if (!parse_string(1,"case|do[ |\\t]+case",NULL)) prev_indent-=tab_size;
		point=*pos2;
		to_column(prev_indent);
		ora_indent=prev_indent+tab_size;
	}else if (parse_string(1,"endcase",NULL)){
		*pos2=point;
		re_search(-1, "[^ \t\n]");	/* find previous non-blank line */
		to_indentation();
		ora_indent=current_column();
		if (!parse_string(1,"(case|otherwise|do[ |\\t]+case)",NULL)) ora_indent-=tab_size;
		point=*pos2;
		to_column(ora_indent);
	}else if (parse_string(1,"endif",NULL)){
		*pos2=point;
		re_search(-1, "[^ \t\n]");	/* find previous non-blank line */
		to_indentation();
		ora_indent=current_column();
		if (!parse_string(1,"(else|if)",NULL)) ora_indent-=tab_size;
		point=*pos2;
		to_column(ora_indent);
	}else if (parse_string(1,"next",NULL)){
		*pos2=point;
		re_search(-1, "[^ \t\n]");	/* find previous non-blank line */
		to_indentation();
		ora_indent=current_column();
		if (!parse_string(1,"for",NULL)) ora_indent-=tab_size;
		point=*pos2;
		to_column(ora_indent);		
	}else if (parse_string(1,"enddo",NULL)){
		*pos2=point;
		re_search(-1, "[^ \t\n]");	/* find previous non-blank line */
		to_indentation();
		ora_indent=current_column();
		if (!parse_string(1,"do[ |\\t]+while",NULL)) ora_indent-=tab_size;
		point=*pos2;
		to_column(ora_indent);		
	}else if (parse_string(1,"((static[ \t]+)?(procedure|function))",NULL)){
		ora_indent=0;
		to_column(ora_indent);
	}else ora_indent=prev_indent;
	case_fold=vecchia_fold;
	point = *pos1;
	free_spot(pos1);
	free_spot(pos2);
	return ora_indent;
}

command do_db_indent() on db_tab['\t']
{
	int orig = point;
	int orig_column = current_column();

	to_indentation();
	if (orig_column > current_column()) {	/* if not in indentation */
		point = orig;			 /* indent like one tab */
		to_column(orig_column + tab_size - orig_column % tab_size);
	} else if (prev_cmd == DB_INDENT)	/* repeated, make bigger */
		to_column(orig_column + tab_size);
	else
		to_column(db_calcola_indent());
	this_cmd = DB_INDENT;
}


command indenta_tutto()
{
	int poi_indent=current_column(),ora_indent=current_column();
	spot inizio = alloc_spot(), fine = alloc_spot(), posizione = alloc_spot();
	int vecchia_fold=case_fold;
	*posizione=point;
	if (point<mark){
		*inizio=point; 
		*fine=mark;
	}else {
		*inizio=mark;
		*fine=point;
	}
	case_fold=1;
	point=*inizio;
	while (point<*fine){
		ora_indent=poi_indent;
		to_indentation();
		if (parse_string(1,"if|do[ |\\t]+while|do[ |\\t]+case",NULL)){
			poi_indent+=tab_size;
		}else if (parse_string(1,"else|elseif|case|otherwise",NULL)){
			ora_indent-=tab_size;
		}else if (parse_string(1,"endif|endcase|enddo",NULL)){
			ora_indent-=tab_size;
			poi_indent-=tab_size;
		}	
		to_column(ora_indent);
		search(1,"\n");
		say("%2d%%",(point-*inizio)*100/(*fine-*inizio));
	}
	point=*posizione;
	free_spot(posizione);
	free_spot(fine);
	free_spot(inizio);
	case_fold=vecchia_fold;
}	


tag_suffix_prg()			/* tagghetta tutte le funzioni dBase in questo file */
{
	int start = point, vecchia_fold = case_fold;
	char func[TAGLEN];
	
	case_fold=1;
	while (re_search(1, "^[ \t]*(stat(i|ic)?[ \t]+)?((proc(e|ed|edu|edur|edure)?)|(func(t|ti|tio|tion)?))")) {
		re_search(1, "[a-zA-Z0-9_]+");
		grab(matchstart, point, func);
		start=matchstart;

		add_tag(func, start);
	}
	case_fold=vecchia_fold;
}

